Exec {
  path => '/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin'
}

hiera_include('default')

# PARAMS
# ======
$main_address = '10.0.0.127'
$admin_address = '192.168.0.127'

## HAPROXY
$haproxy_percona_servers = {
        priority_hostname => 'ocp-tb-1',
        priority_ip => '10.101.32.x',
        hostnames => ['ocp-tb-2', 'ocp-tb-3'],
        ips => ['10.101.32.x', '10.101.32.x'],
      }
# controller hostnames and ips
$haproxy_controller_hosts = ['ocp-tb-7', 'ocp-tb-8']
$haproxy_controller_ips = ['10.101.32.x', '10.101.32.x']

## PERCONA
# every openstack user must be created on rhmk servers. '%' is mysql wildcard.
$mysql_grant_hostname1 = '10.101.32.x'
$mysql_grant_hostname2 = '10.101.32.x'
$mysql_grant_hostname3 = '10.101.32.x'
$mysql_users = {
                # HOSTNAME1 ===========================================
                "keystone@${mysql_grant_hostname1}" => {
                        password_hash => mysql_password('keystone'),
                },
                "glance@${mysql_grant_hostname1}" => {
                        password_hash => mysql_password('glance'),
                },
                "nova@${mysql_grant_hostname1}" => {
                        password_hash => mysql_password('nova'),
                },
                "cinder@${mysql_grant_hostname1}" => {
                        password_hash => mysql_password('cinder'),
                },
                "neutron@${mysql_grant_hostname1}" => {
                        password_hash => mysql_password('neutron'),
                },
		        "ceilometer@${mysql_grant_hostname1}" => {
                        password_hash => mysql_password('ceilometer'),
                },
		        "heat@${mysql_grant_hostname1}" => {
                        password_hash => mysql_password('heat'),
                },
                # HOSTNAME2 ===========================================
                "keystone@${mysql_grant_hostname2}" => {
                        password_hash => mysql_password('keystone'),
                },
                "glance@${mysql_grant_hostname2}" => {
                        password_hash => mysql_password('glance'),
                },
                "nova@${mysql_grant_hostname2}" => {
                        password_hash => mysql_password('nova'),
                },
                "cinder@${mysql_grant_hostname2}" => {
                        password_hash => mysql_password('cinder'),
                },
                "neutron@${mysql_grant_hostname2}" => {
                        password_hash => mysql_password('neutron'),
                },
		        "ceilometer@${mysql_grant_hostname2}" => {
                        password_hash => mysql_password('ceilometer'),
                },
		        "heat@${mysql_grant_hostname2}" => {
                        password_hash => mysql_password('heat'),
                },
                # HOSTNAME3 ===========================================
                "keystone@${mysql_grant_hostname3}" => {
                        password_hash => mysql_password('keystone'),
                },
                "glance@${mysql_grant_hostname3}" => {
                        password_hash => mysql_password('glance'),
                },
                "nova@${mysql_grant_hostname3}" => {
                        password_hash => mysql_password('nova'),
                },
                "cinder@${mysql_grant_hostname3}" => {
                        password_hash => mysql_password('cinder'),
                },
                "neutron@${mysql_grant_hostname3}" => {
                        password_hash => mysql_password('neutron'),
                },
		        "ceilometer@${mysql_grant_hostname3}" => {
                        password_hash => mysql_password('ceilometer'),
                },
		        "heat@${mysql_grant_hostname3}" => {
                        password_hash => mysql_password('heat'),
                },
        }

# create a database for every openstack service.
$mysql_databases =  {
                'keystone' => {},
                'glance' => {},
                'nova' => {},
                'cinder' => {},
                'neutron' => {},
                'ceilometer' => {},
                'heat' => {},
        }

# assign grants for every string user@host/database.table
$mysql_grants = {
                # HOSTNAME1 ===========================================
                "keystone@${mysql_grant_hostname1}/keystone.*" => {
                        user => "keystone@${mysql_grant_hostname1}",
			            table => 'keystone.*',
                },
                "glance@${mysql_grant_hostname1}/glance.*" => {
                        user => "glance@${mysql_grant_hostname1}",
		            	table => 'glance.*',
                },
                "nova@${mysql_grant_hostname1}/nova.*" => {
                        user => "nova@${mysql_grant_hostname1}",
			            table => 'nova.*',
                },
                "cinder@${mysql_grant_hostname1}/cinder.*" => {
                        user => "cinder@${mysql_grant_hostname1}",
		            	table => 'cinder.*',
                },
                "neutron@${mysql_grant_hostname1}/neutron.*" => {
                        user => "neutron@${mysql_grant_hostname1}",
			            table => 'neutron.*',
                },
		         "ceilometer@${mysql_grant_hostname1}/ceilometer.*" => {
                        user => "ceilometer@${mysql_grant_hostname1}",
			            table => 'ceilometer.*',
                },
		        "heat@${mysql_grant_hostname1}/heat.*" => {
                        user => "heat@${mysql_grant_hostname1}",
		            	table => 'heat.*',
                },
                # HOSTNAME2 ===========================================
                "keystone@${mysql_grant_hostname2}/keystone.*" => {
                        user => "keystone@${mysql_grant_hostname2}",
			            table => 'keystone.*',
                },
                "glance@${mysql_grant_hostname2}/glance.*" => {
                        user => "glance@${mysql_grant_hostname2}",
		            	table => 'glance.*',
                },
                "nova@${mysql_grant_hostname2}/nova.*" => {
                        user => "nova@${mysql_grant_hostname2}",
			            table => 'nova.*',
                },
                "cinder@${mysql_grant_hostname2}/cinder.*" => {
                        user => "cinder@${mysql_grant_hostname2}",
		            	table => 'cinder.*',
                },
                "neutron@${mysql_grant_hostname2}/neutron.*" => {
                        user => "neutron@${mysql_grant_hostname2}",
			            table => 'neutron.*',
                },
		         "ceilometer@${mysql_grant_hostname2}/ceilometer.*" => {
                        user => "ceilometer@${mysql_grant_hostname2}",
			            table => 'ceilometer.*',
                },
		        "heat@${mysql_grant_hostname2}/heat.*" => {
                        user => "heat@${mysql_grant_hostname2}",
		            	table => 'heat.*',
                },
                # HOSTNAME3 ===========================================
                "keystone@${mysql_grant_hostname3}/keystone.*" => {
                        user => "keystone@${mysql_grant_hostname3}",
			            table => 'keystone.*',
                },
                "glance@${mysql_grant_hostname3}/glance.*" => {
                        user => "glance@${mysql_grant_hostname3}",
		            	table => 'glance.*',
                },
                "nova@${mysql_grant_hostname3}/nova.*" => {
                        user => "nova@${mysql_grant_hostname3}",
			            table => 'nova.*',
                },
                "cinder@${mysql_grant_hostname3}/cinder.*" => {
                        user => "cinder@${mysql_grant_hostname3}",
		            	table => 'cinder.*',
                },
                "neutron@${mysql_grant_hostname3}/neutron.*" => {
                        user => "neutron@${mysql_grant_hostname3}",
			            table => 'neutron.*',
                },
		         "ceilometer@${mysql_grant_hostname3}/ceilometer.*" => {
                        user => "ceilometer@${mysql_grant_hostname3}",
			            table => 'ceilometer.*',
                },
		        "heat@${mysql_grant_hostname3}/heat.*" => {
                        user => "heat@${mysql_grant_hostname3}",
		            	table => 'heat.*',
                },
        }

## RABBIT
#  rabbit node variables

$rabbit_hostnames = ['rb-tb-1-priv','rb-tb-2-priv','rb-tb-3-priv']

# NODE DEFINITION
# ===============

## RHMK NODES

#node '<RHMK_HOSTNAME1>' {
#  class {'iaas::role::rhmk':
#       # percona_master to be true only if renewing the cluster
#       percona_master => true,
#       mongo_master     => true,
#       # mongo_bootstrap to be commented during replica sets cluster configuration
#       mongo_bootstrap => true,
#       keepalived_state => 'MASTER',
#       keepalived_priority => 102,
#       haproxy_percona_servers => $haproxy_percona_servers,
#       mysql_users => $mysql_users,
#       mysql_databases => $mysql_databases,
#       mysql_grants => $mysql_grants,
#       main_address => $main_address,
#       admin_address => $admin_address, 
#       haproxy_controller_hosts => $haproxy_controller_hosts, 
#       haproxy_controller_ips => $haproxy_controller_ips, 
#       rabbit_hostname => $rabbit_hostnames[0],
##set zookeeper index (1,..,N)
#       zookeeper_id => '1',
#  }
#}
#
#node '<RHMK_HOSTNAME2>' {
# class {'iaas::role::rhmk':
#       keepalived_state => 'BACKUP',
#       keepalived_priority => 101,
#       haproxy_percona_servers => $haproxy_percona_servers,
#       mysql_users => $mysql_users,
#       mysql_databases => $mysql_databases,
#       mysql_grants => $mysql_grants,
#       main_address => $main_address,
#       admin_address => $admin_address, 
#       haproxy_controller_hosts => $haproxy_controller_hosts, 
#       haproxy_controller_ips => $haproxy_controller_ips, 
#       rabbit_hostname => $rabbit_hostnames[1],
##set zookeeper index (1,..,N)
#       zookeeper_id => '2',
# }
#}
#
#node '<RHMK_HOSTNAME3>' {
# class {'iaas::role::rhmk':
#       keepalived_state => 'BACKUP',
#       keepalived_priority => 100,
#       haproxy_percona_servers => $haproxy_percona_servers,
#       mysql_users => $mysql_users,
#       mysql_databases => $mysql_databases,
#       mysql_grants => $mysql_grants,
#       main_address => $main_address,
#       admin_address => $admin_address, 
#       haproxy_controller_hosts => $haproxy_controller_hosts, 
#       haproxy_controller_ips => $haproxy_controller_ips, 
#       rabbit_hostname => $rabbit_hostnames[2],
##set zookeeper index (1,..,N)
#       zookeeper_id => '3',
# }
#}

## CEPH STORAGE NODES

#node '<storage_hostname>' {
#
# include 'iaas::role::storage'
#
# ceph::osd {
#      '/dev/vdb':
#        journal => '/osd1';
#
#      '/dev/vdc':
#        journal => '/osd2';
#
#      '/dev/vdd':
#        journal => '/osd3',
# }
# 
# ceph::key {
#  'client.admin':
#    secret => 'AQDgL/hUSC2kLBAAnWJaSiqJG+YMk+XV9sapnw==',
#    cap_mon => 'allow *',
#    cap_osd => 'allow *',
#    cap_mds => 'allow',
#    inject => 'true',
#    inject_as_id => 'mon.',
#    inject_keyring => "/var/lib/ceph/mon/ceph-$::hostname/keyring";
#
#  'client.bootstrap-osd':
#    secret => 'AQDlL/hUUCpdFBAAZeo6mKj4yeKPmVKfUY5awA==',
#    cap_mon => 'allow profile bootstrap-osd',
#    keyring_path => '/var/lib/ceph/bootstrap-osd/ceph.keyring',
#    inject => 'true',
#    inject_as_id => 'mon.',
#    inject_keyring => "/var/lib/ceph/mon/ceph-$::hostname/keyring";
#
#  'client.glance':
#    secret => 'AQBgGdJUCPwjLRAARZ0KEaxewYcYHT3j5Gl5Cg==',
#    cap_mon => 'allow r',
#    cap_osd => 'allow class-read object_prefix rbd_children, allow rwx pool=images',
#    inject => 'true',
#    inject_as_id => 'mon.',
#    inject_keyring => "/var/lib/ceph/mon/ceph-$::hostname/keyring";
#
#  'client.cinder':
#    secret => 'AQAvxQpVKJ03KxAADFv78tedrAWZx1SoRdsQUA==',
#    cap_mon => 'allow r',
#    cap_osd => 'allow class-read object_prefix rbd_children, allow rwx pool=volumes, allow rwx pool=vms, allow rx pool=images',
#    inject => 'true',
#    inject_as_id => 'mon.',
#    inject_keyring => "/var/lib/ceph/mon/ceph-$::hostname/keyring";
#
#  'client.cinder-backup':
#    secret => 'AQBKvuVUMHvaGhAADT6nvBv9LFs7dqpB8Kis0Q==',
#    cap_mon => 'allow r',
#    cap_osd => 'allow class-read object_prefix rbd_children, allow rwx pool=backups',
#    inject => 'true',
#    inject_as_id => 'mon.',
#    inject_keyring => "/var/lib/ceph/mon/ceph-$::hostname/keyring",
# }
#
# ceph::pool { 'images':
#                 pg_num => 128;
#               'volumes':
#                 pg_num => 128;
#               'vms':
#                 pg_num => 128;
#               'backups':
#                 pg_num => 128,
# }
#
#}


## CONTROLLER NODE(s)
#node '<CONTROLLER_HOSTNAME>' {
#
# include 'iaas::role::controller'
#
# ceph::key {
#  'client.glance':
#    secret => 'AQBgGdJUCPwjLRAARZ0KEaxewYcYHT3j5Gl5Cg==',
#    cap_mon => 'allow r',
#    cap_osd => 'allow class-read object_prefix rbd_children, allow rwx pool=images',
#    user => 'glance',
#    group => 'glance',
#    mode => '0550';
#
#  'client.cinder':
#    secret => 'AQAvxQpVKJ03KxAADFv78tedrAWZx1SoRdsQUA==',
#    cap_mon => 'allow r',
#    cap_osd => 'allow class-read object_prefix rbd_children, allow rwx pool=volumes, allow rwx pool=vms, allow rx pool=images',
#    user => 'cinder',
#    group => 'cinder',
#    mode => '0550';
#
#  'client.cinder-backup':
#    secret => 'AQBKvuVUMHvaGhAADT6nvBv9LFs7dqpB8Kis0Q==',
#    cap_mon => 'allow r',
#    cap_osd => 'allow class-read object_prefix rbd_children, allow rwx pool=backups',
#    user => 'cinder',
#    group => 'cinder',
#    mode => '0550', 
# }
#
#}


##NETWORK NODE(s)
#node '<NETWORK_HOSTNAME>' {
# include 'iaas::role::network'
#}

##COMPUTE NODE(s)
#node '<COMPUTE_HOSTNAME>' {
# include 'iaas::role::compute'
#
# ceph::key {
#  'client.admin':
#    secret => 'AQDgL/hUSC2kLBAAnWJaSiqJG+YMk+XV9sapnw==',
#    cap_mon => 'allow *',
#    cap_osd => 'allow *',
#    cap_mds => 'allow',
#    user => 'root',
#    group => 'root',
#    mode => '0550';
#
#  'client.cinder':
#    secret => 'AQAvxQpVKJ03KxAADFv78tedrAWZx1SoRdsQUA==',
#    cap_mon => 'allow r',
#    cap_osd => 'allow class-read object_prefix rbd_children, allow rwx pool=volumes, allow rwx pool=vms, allow rx pool=images',
#    user => 'nova',
#    group => 'nova',
#    mode => '0550';
# }
#
#}
